<template>
  <div style="overflow-x: auto">
    <h1>Appointment List</h1>

    <div v-if="list.length == 0">
      <preloader />
    </div>
    <table
      class="table table-condensed table-hover mt-2"
      v-if="list.length > 0"
    >
      <thead>
        <tr>
          <th scope="col" v-for="(col, index) in colItems" :key="index">
            {{ col.name }}
          </th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(item, index) in list" :key="index">
          <th scope="row">{{ index + 1 }}</th>
          <td>{{ date(item.fields.appointment_date) }}</td>
          <td>{{ item.fields.appointment_postcode }}</td>
          <td>
            {{
              item.fields.contact_phone != null
                ? item.fields.contact_phone[0]
                : ""
            }}
          </td>
          <td>
            {{
              item.fields.contact_name != null
                ? item.fields.contact_name[0]
                : ""
            }}
          </td>
          <td>
            {{
              item.fields.contact_surname != null
                ? item.fields.contact_surname[0]
                : ""
            }}
          </td>
          <td>
            {{
              item.fields.contact_email != null
                ? item.fields.contact_email[0]
                : ""
            }}
          </td>
          <td>
            {{
              item.fields.agent_name != null ? item.fields.agent_name[0] : ""
            }}
          </td>
          <td>
            {{
              item.fields.agent_surname != null
                ? item.fields.agent_surname[0]
                : ""
            }}
          </td>
          <td v-if="!isActive(item.fields.appointment_date)">
            <router-link :to="{ name: 'edit', params: { item:item }}"> Edit  </router-link>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
import axios from "axios";
import preloader from "@/components/Preloader";

const URL = "https://api.airtable.com/v0/appgykZBGTF92MnHu/Appointments/";
const ADDRESS_URL = "http://api.postcodes.io/postcodes/";
const OFFICE_POST_CODE = "cm27pj";

export default {
  data() {
    return {
      list: [],
      colItems: [
        { name: "#" },
        { name: "Appointment date" },
        { name: "Appointment post" },
        { name: "Contact phone" },
        { name: "Contact name" },
        { name: "Contact surname" },
        { name: "Contact email" },
        { name: "Agent name" },
        { name: "Agent surname" },
      ],
    };
  },
  components: {
    preloader,
  },

  methods: {
    async getAddress(postCode) {
      const res = await axios.get(ADDRESS_URL + postCode);
      return res.data.status;
    },

    date: (date) => new Date(date).toLocaleString(),
    isActive: (date) => new Date().getTime() - new Date(date).getTime() > 0,
    fetchList() {
      axios
        .get(URL, {
          headers: {
            Authorization: "Bearer keyYIULY6l1seh10Q",
          },
        })
        .then((res) => {
          this.list = res.data.records;
        })
        .catch((err) => console.log(err));
    },
  },

  mounted() {
    this.fetchList();
  },
};
</script>

<style>
tr.disabled {
  background-color: grey;
}
</style>
